const OTTURL = 'https://3uykhryun5.execute-api.us-east-1.amazonaws.com/prod';
const _EVENTID_ = '669781';
const _TYPE_ = 'vod';
const _M3U8_ = 'https://d1ov8a29la3c5g.cloudfront.net/live/2021-03-16T15-38-54-647-03-00--F-nix-vs--Argentino-de-Quilmes/2021-03-16T15-38-54-647-03-00--F-nix-vs--Argentino-de-Quilmes.m3u8';
const playerUniqueId = 'Ku85E0I2';
const cookieCognito = 'aws.cognito.identity-id.us-east-1:59cf7619-1bf8-4dc0-a968-718a65a2eb30';

/**
 * fijo
 */
const _PLAYERVERSION_ = 'v1.0.0';
const _METRICS_URL_ = `${OTTURL}/metrics/ping`;
const _METRICSPLAY_URL_ = `${OTTURL}/metrics/play`;
const _ERROR_URL_ = `${OTTURL}/metrics/error`;
const playerBase = `https://d1ov8a29la3c5g.cloudfront.net/live/players/jwplayer_${playerUniqueId}.js`;
const playerContainer = `ott_botr_${_EVENTID_}_${playerUniqueId}_div`;
const setUpSettings = {
  playlist: [
    {
      file: _M3U8_,
    },
  ],
};

document.write(`<div id="${playerContainer}"></div>`);

(function () {
  installPlayerScript({
    context: document,
    onLoadCallback: initialize,
    scriptSrc: playerBase,
    uniqueScriptId: playerUniqueId,
  });
  installPlayerScript({
    context: document,
    scriptSrc: 'https://d1ov8a29la3c5g.cloudfront.net/live/players/bowser.min.js',
  });
  installPlayerScript({
    context: document,
    onLoadCallback: initComscore,
    scriptSrc: 'https://d1ov8a29la3c5g.cloudfront.net/live/players/comscore.js',
  });
})();

function uuid() {
  const hashTable = ['a', 'b', 'c', 'd', 'e', 'f', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'];
  let uuid = [];
  for (let i = 0; i < 35; i++) {
    if (i === 7 || i === 12 || i === 17 || i === 22) {
      uuid[i] = '-';
    } else {
      uuid[i] = hashTable[Math.floor(Math.random() * hashTable.length - 1)];
    }
  }
  return uuid.join('');
}

function installPlayerScript(_ref) {
  var context = _ref.context,
    onLoadCallback = _ref.onLoadCallback,
    scriptSrc = _ref.scriptSrc,
    uniqueScriptId = _ref.uniqueScriptId;

  var jwPlayerScript = context.createElement('script');
  jwPlayerScript.id = uniqueScriptId;
  jwPlayerScript.src = scriptSrc;
  jwPlayerScript.onload = onLoadCallback;

  context.head.appendChild(jwPlayerScript);
}

const map = {
  false: 0,
  true: 1,
  undefined: '',
  null: '',
};

function getbeat() {
  let vq = window.player.getVisualQuality();
  let w = window.player.getWidth();
  let h = window.player.getHeight();

  return {
    c: map[localStorage.getItem('ott_cast')], // cast
    cs: w + 'x' + h, // container size
    e: _EVENTID_, // eventid
    fs: map[window.player.getFullscreen()], // fs
    m: map[window.player.getMute()], // mute
    p: window.player.getPosition(), // posicion vod or tiempo visto live

    q: vq?.level?.height, // calidad
    qa: map[vq?.level?.label === 'auto'], // calidad auto 1 manual 0
    s: window.player.getState(), // idle playing buffering paused
    si: localStorage.getItem('ott_sessionId'), // sessionid
    t: _TYPE_, // vod or live
    ts: new Date().getTime(), // timestamp
    u: localStorage.getItem('ott_userId'), // userid
    v: window.player.getVolume(), // volumen
    vw: window.player.getViewable(), // visible en pantalla
  };
}

function geterrorinfo() {
  return {
    ...getplayinfo(),
    ...getbeat(),
  };
}

function getplayinfo() {
  let bowser = window.bowser.parse(window.navigator.userAgent);

  return {
    a: 0, // app
    ab: map[window.player.getAdBlock()], // adblock?
    b: bowser.browser.name, // browser
    d: bowser.platform.type, // platform
    e: _EVENTID_, // event id
    mu: window.player
      .getPlaylist()
      .map((e) => e.file)
      .toString(), // event m3u8
    pv: _PLAYERVERSION_, //player version
    o: window.location.origin, // origin
    os: bowser.os.name, // ssoo
    r: window.player.getProvider().name, // render
    si: localStorage.getItem('ott_sessionId'), // sessionid
    t: _TYPE_, // vod or live
    ts: new Date().getTime(), // timestamp
    u: localStorage.getItem('ott_userId'), // userid
  };
}

function sentPlay() {
  function postPlay(data) {
    let queryString = Object.keys(data)
      .map((key) => key + '=' + encodeURIComponent(data[key]))
      .join('&');
    var xhttp = new XMLHttpRequest();
    xhttp.open('GET', `${_METRICSPLAY_URL_}?${queryString}`, true);
    xhttp.setRequestHeader('Content-type', 'application/json');
    xhttp.send();
  }
  let info = getplayinfo();
  console.log(info);
  postPlay(info);
}

function sentHeartbeat() {
  function postMetrics(data) {
    let queryString = Object.keys(data)
      .map((key) => key + '=' + encodeURIComponent(data[key]))
      .join('&');
    var xhttp = new XMLHttpRequest();
    xhttp.open('GET', `${_METRICS_URL_}?${queryString}`, true);
    xhttp.setRequestHeader('Content-type', 'application/json');
    xhttp.send();
  }
  let info = getbeat();
  console.log(info);
  postMetrics(info);
}

function sentError(er) {
  function postErrorMetrics(data) {
    let queryString = Object.keys(data)
      .map((key) => key + '=' + encodeURIComponent(data[key]))
      .join('&');
    var xhttp = new XMLHttpRequest();
    xhttp.open('GET', `${_ERROR_URL_}?${queryString}`, true);
    xhttp.setRequestHeader('Content-type', 'application/json');
    xhttp.send();
  }
  let error = {
    ...geterrorinfo(),
    er,
  };
  postErrorMetrics(error);
}

function _beatStart() {
  sentPlay();
  sentHeartbeat();
  window.heartbeat = setInterval(sentHeartbeat, 60 * 1e3); // TODO change to 60
}

function _beatStop() {
  sentHeartbeat();
  clearInterval(window.heartbeat);
}

function attemptFailover() {
  console.log('attemptFailover');
  _beatStop();
  initialize();
  window.player.play();
}

function collectstaticinfo() {
  let sessionid = uuid();
  localStorage.setItem('ott_sessionId', sessionid);
  localStorage.setItem('ott_userId', localStorage.getItem(cookieCognito) || sessionid);
  localStorage.setItem('ott_eventoId', _EVENTID_);
}

function cleanlocalstorage() {
  localStorage.removeItem('ott_cast');
  localStorage.removeItem('ott_eventoId');
  localStorage.removeItem('ott_sessionId');
  localStorage.removeItem('ott_userId');
}

async function initComscore() {
  async function sleep(ms) {
    return new Promise((resolve) => setTimeout(resolve, ms));
  }
  for (;;) {
    if (window.player) {
      window.ns_.StreamingAnalytics.JWPlayer(window.player, {
        publisherId: '6906409',
        labelmapping: `c3="TYCSPORTSPLAY.COM", ns_st_pu="TYCSPORTSPLAY.COM", ns_st_ci="${_EVENTID_}", `,
      });
      break;
    }
    await sleep(500);
  }
}

function initialize() {
  if (!setUpSettings) return;

  cleanlocalstorage();
  collectstaticinfo();
  window.player = window.jwplayer(playerContainer).setup(setUpSettings);

  window.player.on('error', (error) => {
    sentError(String(error.code + ': ' + error.message));
    if (error.code === 230001) {
      attemptFailover();
    }
  });

  window.player.on('cast', (event) => {
    localStorage.setItem('ott_cast', String(event?.active));
  });

  window.player.on('firstFrame', _beatStart);

  window.player.on('complete', _beatStop);
}
